# coding: utf-8

# from java.text import SimpleDateFormat
from java.util import ArrayList
import json
from ru.curs.celesta.showcase.utils import XMLJSONConverter
try:
    from ru.curs.showcase.core.jython import JythonDTO
    from ru.curs.showcase.core.selector import ResultSelectorData
    from ru.beta2.extra.gwt.ui.selector.api import DataRecord
except:
    from ru.curs.celesta.showcase import JythonDTO
    
from edu._edu_orm import educational_groupCursor, vw_edu_group_personsCursor


def groupListAndCount(context, main=None, add=None, filterinfo=None, session=None, params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    groupCur = educational_groupCursor(context)
    groupCur.setRange('status', 30)
    # фильтрация записей по данным, введенным пользователем в селекторе
    if curValue:
        groupCur.setFilter('group_name', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    # сортировка
    groupCur.orderBy('group_name')
#     subjectType.limit(firstrecord, recordcount)    
    recordList = ArrayList()
    # ограничение на единовременный вывод данных    
    a = firstRecord
    b = firstRecord + recordCount 
    count = 0
    for qti in groupCur.iterate():
        if count>=a and count<b: 
            rec = DataRecord()
            rec.id = str(qti.group_id)
            rec.name = qti.group_name
            recordList.add(rec)
        count += 1
            
    groupCur.close()
    
    return ResultSelectorData(recordList, count)


def studentListAndCount(context, main=None, add=None, filterinfo=None, session=None, params=None, curValue=None, startsWith=None, firstRecord=None, recordCount=None):
    try:
        group_id = int(json.loads(XMLJSONConverter.xmlToJson(params))['schema']['filter']['id']['#text'])
    except:
        group_id = -1
    personsCur = vw_edu_group_personsCursor(context)
    personsCur.setRange('group_id', group_id)
    if curValue:
        personsCur.setFilter('surname', "@%s'%s'%%" % ("%"*(not startsWith), curValue))
    personsCur.orderBy('surname', 'name', 'patronymic')

    recordList = ArrayList()
    # ограничение на единовременный вывод данных    
    a = firstRecord
    b = firstRecord + recordCount 
    count = 0
    for person in personsCur.iterate():
        if count>=a and count<b: 
            rec = DataRecord()
            rec.id = str(person.person_id)
            rec.name = u'{} {} {}'.format(person.surname, person.name, person.patronymic)
            recordList.add(rec)
        count += 1            
    personsCur.close()
    
    return ResultSelectorData(recordList, count)
